<?php
	// Setting Maximum Allowed File Dimension in bytes (ATTENZIONE: trovare una funzione che peschi dalla max dim del file e del server)
	$max_dim = 104857600; // 100 Mb
	// Setting Target Upload Directory
	$target_dir = "upload/";
	// Setting Conversion Output Directory
	$output_dir = "output/";
	// Home
	$home = "http://onlinevideotranscoder.com/";
	// Allowed File Formats	
	$file_formats = array('.mp4','.avi','.wmv','.mkv','.3gp','.f4v','.flv','.mpg','.ogg','.mov','.mpeg','.yuv'); 
	$err = 0;
	// Checking File
	$file_field = 'myfile';

	if(!isset($_FILES[$file_field]) || $_FILES[$file_field]['size']==0) {
 		echo "No file has been selected!"; }
	 
	elseif($_FILES[$field_field]['size']>$max_dim)	{
  		$max_dim=$max_dim/(1024^2);
		echo "The selected file is greater than the size limit of $max_dim Mbytes!"; }	

	else {
		$filename=$_FILES[$file_field]['name'];
  		$format = strtolower(substr($filename, strrpos($filename, "."), strlen($filename)-strrpos($filename, "."))); 
		if(!in_array($format,$file_formats)) {
			echo "File format not supported; <br/>Supported formats: ".implode(", ",$arr_ext)."<br/>";
			$err = 1; }
		}	
	// File Uploading
	if($err==0) {
   		$t = time();
		// Inserting Safe Characters in the Filename
		$target_file = preg_replace("/[[:space:]]/" , "_", $_FILES[$file_field]['name']);
		$target_file = preg_replace("/[^[:alnum:]._-]/" , "", $target_file);
		// Removing the Extension in the Filename
   		$filename = substr($target_file,0,strrpos($target_file,'.'));
   		if(move_uploaded_file($_FILES[$file_field]['tmp_name'], $target_dir.$t.'_'.$target_file)) {
			chmod($target_dir.$t.'_'.$target_file,0777); 
			echo "Upload Successful. Transcoding now...<br/>";
			// File Converting
			$format = $_POST['format'];
			$input = $target_dir.$t.'_'.$target_file;
			switch($format) {
				/*case 'iphone':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-s 640x480 -vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'ipad':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-s 1280x720 -vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case '720p':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-s 1280x720 -vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;*/
				case 'mp4':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'avi1':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$format = 'avi';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;				
					exec($string, $output_string, $retval);
				break;
				case 'avi2':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec wmv2 -sameq';
					$acodec = '-acodec libmp3lame -ab 192k';
					$format = 'avi';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;	
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;			
					exec($string, $output_string, $retval);
				break;
				case 'avi3':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec wmv2 -sameq';
					$acodec = '-acodec wmav2 -ab 192k';
					$format = 'avi';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'avi4':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libmp3lame -ab 192k';
					$format = 'avi';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'flv':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'f4v':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'mov':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'wmv':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec wmv2 -sameq';
					$acodec = '-acodec wmav2 -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				/*case 'ogg':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libtheora -sameq';
					$acodec = '-acodec libvorbis -ab 192k';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;*/
				case 'mkv1':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libfaac -ab 192k';
					$format = 'mkv';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'mkv2':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec wmv2 -sameq';
					$acodec = '-acodec libmp3lame -ab 192k';
					$format = 'mkv';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'mkv3':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec wmv2 -sameq';
					$acodec = '-acodec wmav2 -ab 192k';
					$format = 'mkv';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
				case 'mkv4':
					$input = $target_dir.$t.'_'.$target_file;
					$vcodec = '-vcodec libx264 -vpre medium -vpre main -crf 20';
					$acodec = '-acodec libmp3lame -ab 192k';
					$format = 'mkv';
					$output = $output_dir.$t.'_'.$filename.'.'.$format;					
					$string = 'ffmpeg -i '.$input.' '.$vcodec.' '.$acodec.' '.$output;
					exec($string, $output_string, $retval);
				break;
			}		
			if ($retval==0) {
				echo "<br/> Clip successfully converted.";  
				echo "<br/> Click <a href=\"".$home.$output."\">here</a> to download your clip!";
				echo "<br/> (Right Click and Save As...)";
			}
			else { 
				echo "<br/> Sorry, there was an error converting the clip. <a href=\"http://onlinevideotranscoder.com/index.php\">Retry</a> or <a href=\"contact.php\">contact</a> the webmaster."; 		}	
		}
   		else {
			echo "File upload unsuccessful; please retry!"; }
  		}
  	else {
		echo "File upload unsuccessful; please retry!"; }
